stages:
  - test
  - build-application
  - build-container
  - push-container

services:
  - postgres:latest
  - docker:dind

variables:
  POSTGRES_DB: postgres
  POSTGRES_USER: postgres
  POSTGRES_PASSWORD: "mysecretpassword"
  TAG_NAME: registry.gitlab.com/hacklabor/lagerverwaltung/warehouse-service/warehouse-service:latest

test:
  stage: test
  image: gradle:5.1.1-jdk11-slim
  artifacts:
    when: on_failure
    paths:
      - /builds/hacklabor/lagerverwaltung/warehouse-service/build/reports/
  variables:
    JDBC_URL: "jdbc:postgresql://postgres:5432/postgres"
    DB_USERNAME: "postgres"
    DB_PASSWORD: "mysecretpassword"
  script:
    - gradle check

build-application:
  stage: build-application
  only:
    - master
  image: gradle:5.1.1-jdk11-slim
  artifacts:
    when: on_success
    paths:
      - ./build
  script:
    - gradle build

build-container:
  stage: build-container
  only:
    - master
  image: docker:latest
  artifacts:
    when: on_success
    paths:
      - ./warehouse-service-image.tar
  script:
    - docker build -t $TAG_NAME .
    - docker save $TAG_NAME > warehouse-service-image.tar

push-container:
  stage: push-container
  only:
    - master
  image: docker:latest
  variables:
    GIT_STRATEGY: none
  script:
    - docker load -i warehouse-service-image.tar
    - echo "$CI_REGISTRY_PASSWORD" | docker login -u $CI_REGISTRY_USER --password-stdin registry.gitlab.com/hacklabor/lagerverwaltung/warehouse-service
    - docker push $TAG_NAME
